#include "ot4xb.ch"
//-------------------------------------------------------------------------------------------------------------------------
CLASS TMapiSendMsg
EXPORTED:
VAR _pt,_ad,_as,_at,_hs,_apd
VAR cTitle,cText,nLastError
       // ---------------------------------------------------------------------------------
INLINE METHOD init()
       ::_pt := ::_ad := ::_as := ::_at := ::cTitle := ::cText  := ""
       ::nLastError := 0
       ::_hs := 0
       ::_apd := {}
       return Self
       // ---------------------------------------------------------------------------------
INLINE METHOD PushDir() 
       local n  := @kernel32:GetCurrentDirectoryW(0,0)  
       local cd := ChrR(0,(n+1)*2)
       @kernel32:GetCurrentDirectoryW(n,@cd)  
       aadd( ::_apd , cd )
       return NIL
       // ---------------------------------------------------------------------------------
INLINE METHOD PopDir()
       local n := Len( ::_apd )
       if n > 0
          @kernel32:SetCurrentDirectoryW(::_apd[n])
          asize(::_apd,n-1)
       end
       return NIL
       // ---------------------------------------------------------------------------------
INLINE METHOD Release()
       aEval( PeekDWord(::_pt,,Len(::_pt)/4) , {|p| _xfree(p) } )
       ::_pt := ::_ad := ::_as := ::_at := ::cTitle := ::cText  := ""
       return Self
       // ---------------------------------------------------------------------------------
INLINE METHOD LogOn(cProfile,cPwd,lDwnl,lNew,lLogUi,lPwdUi)
       local nf := 0
       local h  := 0
       if( !Empty(lDwnl ) ) ; nf := nOr(nf,0x1000) ; end
       if( !Empty(lNew  ) ) ; nf := nOr(nf,2) ; end
       if( !Empty(lLogUI) ) ; nf := nOr(nf,1) ; end
       if( !Empty(lPwdUi) ) ; nf := nOr(nf,0x20000) ; end  
       ::PushDir()
       ::nLastError := FpQCall({"mapi32","MAPILogon"},"__sl__sl__pt__pt__sl__sl_@sl",0,cProfile,cPwd,nf,0,@h)
       ::PopDir()
       if ::nLastError == 0 ; ::_hs := h ; end
       return ::nLastError == 0
       // ---------------------------------------------------------------------------------
INLINE METHOD LogOff()
       local h := ::_hs ; ::_hs := 0
       ::nLastError := 0
       if !Empty( h )
          ::PushDir()
          ::nLastError := @mapi32:MAPILogoff(h,0,0,0)
          ::PopDir()
       end
       return ::nLastError == 0
       // ---------------------------------------------------------------------------------
INLINE METHOD Subject(cStr)           ; DEFAULT cStr := "" ; ::cTitle := cStr ;           return Self
INLINE METHOD Body(cStr)              ; DEFAULT cStr := "" ; ::cText := cStr;             return Self
INLINE METHOD Sender(cEmail,cName)    ; ::_as += __i32(0,0,::_T(cName),::_T(cEmail),0,0); return Self
INLINE METHOD Recipient(cEmail,cName) ; ::_ad += __i32(0,1,::_T(cName),::_T(cEmail),0,0); return Self
INLINE METHOD CC(cEmail,cName)        ; ::_ad += __i32(0,2,::_T(cName),::_T(cEmail),0,0); return Self
INLINE METHOD BCC(cEmail,cName)       ; ::_ad += __i32(0,3,::_T(cName),::_T(cEmail),0,0); return Self
INLINE METHOD File(cFile,cName)       ; ::_at += __i32(0,0,-1,::_T(cFile),::_T(cName),0); return Self
       // ---------------------------------------------------------------------------------
INLINE METHOD _T(cc);local p := 0;if Valtype(cc) == "C";::_pt += __i32( p := _xgrab(cc) );end;return p
       // ---------------------------------------------------------------------------------
INLINE METHOD Send(lDialog,lLogonUI,lNewSession)
       local nf
       local msg := __i32(0,::_T(::cTitle),::_T(::cText),0,0,::_T(ChrR(0,4)),0)     +;
                    __i32(iif(Empty(::_as),0,::_T(::_as)))                          +;
                    iif(Empty(::_ad),__i32(0,0),__i32( Len(::_ad)/24,::_T(::_ad)))  +;
                    iif(Empty(::_at),__i32(0,0),__i32( Len(::_at)/24,::_T(::_at)))
       DEFAULT lDialog      := .F.
       DEFAULT lLogonUI     := .F.
       DEFAULT lNewSession  := .F.
       nf := nOr(iif(Empty(::_as) .or. lDialog,8,0),iif(lLogonUI,1,0),iif(lNewSession,2,0))
       ::PushDir()
       ::nLastError := @mapi32:MAPISendMail(::_hs,0,msg,nf,0)
       ::PopDir()
       ::Release()
       return ::nLastError == 0
       // ---------------------------------------------------------------------------------
INLINE METHOD cError()
       local n := ::nLastError
       do case
          case Empty(n) ; return "OK"
          case n ==  1  ; return "USER_ABORT"
          case n ==  2  ; return "FAILURE"
          case n ==  3  ; return "LOGON_FAILURE"
          case n ==  4  ; return "DISK_FULL"
          case n ==  5  ; return "INSUFFICIENT_MEMORY"
          case n ==  6  ; return "ACCESS_DENIED"
          case n ==  8  ; return "TOO_MANY_SESSIONS"
          case n ==  9  ; return "TOO_MANY_FILES"
          case n == 10  ; return "TOO_MANY_RECIPIENTS"
          case n == 11  ; return "ATTACHMENT_NOT_FOUND"
          case n == 12  ; return "ATTACHMENT_OPEN_FAILURE"
          case n == 13  ; return "ATTACHMENT_WRITE_FAILURE"
          case n == 14  ; return "UNKNOWN_RECIPIENT"
          case n == 15  ; return "BAD_RECIPTYPE"
          case n == 16  ; return "NO_MESSAGES"
          case n == 17  ; return "INVALID_MESSAGE"
          case n == 18  ; return "TEXT_TOO_LARGE"
          case n == 19  ; return "INVALID_SESSION"
          case n == 20  ; return "TYPE_NOT_SUPPORTED"
          case n == 21  ; return "AMBIGUOUS_RECIPIENT"
          case n == 22  ; return "MESSAGE_IN_USE"
          case n == 23  ; return "NETWORK_FAILURE"
          case n == 24  ; return "INVALID_EDITFIELDS"
          case n == 25  ; return "INVALID_RECIPS"
          case n == 26  ; return "NOT_SUPPORTED"
       endcase
       return "UNKNOW ERROR"
       // ---------------------------------------------------------------------------------
ENDCLASS
//-------------------------------------------------------------------------------------------------------------------------
